#!/usr/bin/perl

# ---------------------------------------------------------------------------------------------------------

use strict;
use warnings;

use Tk;

use Win32;
use Win32::GUI;
use Win32::Process;

# ---------------------------------------------------------------------------------------------------------	

sub Fehler_Hilfe_Oberflaeche {

	my $Fenster_Fehler_Hilfe = MainWindow -> new( -title => "Fehler - Hilfe" );
	
	my $Breite = 560;
	my $Hoehe  = 580;
	
	$Fenster_Fehler_Hilfe -> geometry( $Breite . 'x' . $Hoehe );
	$Fenster_Fehler_Hilfe -> update;

	my $Top_Level = $Fenster_Fehler_Hilfe -> toplevel;
	
	my $Fehler_Hilfe_Identifier     = $_[ 0 ];
	my $Fehler_Verarbeitung_Fenster = $_[ 1 ];
		
	$_[ 1 ] -> Hide( );
	
	# ---------------------------------------------------------------------------------------------------------
	
	my %SQL_Server_Werte = (  "3004" => "Fehler bei der Identifizierung des Private - Keys für" 	    . "\n" .
							            "die SSL - Verbindung."                                      	. "\n" ,
		
							);
	    
	my $Betroffene_Bereiche = "";
	
	# ---------------------------------------------------------------------------------------------------------

	if( grep { $Fehler_Hilfe_Identifier eq $_ } "0000" .. "0005" ) { $Betroffene_Bereiche = "Config - Datei & Parsing"; }
	if( grep { $Fehler_Hilfe_Identifier eq $_ } "2000" .. "2005" ) { $Betroffene_Bereiche = "SQL - Server"; }
	if( grep { $Fehler_Hilfe_Identifier eq $_ } "3000" .. "3005" ) { $Betroffene_Bereiche = "SSL - Server"; }

	# ---------------------------------------------------------------------------------------------------------

	$Fenster_Fehler_Hilfe -> Label( -text   => "Fehler - Nummer" ,
								    -height => 1                 ,
								    -width  => 16                , 
									-border => 0                 ,
								    -relief => 'groove'          ,
								    -anchor => "w"      
								  
								  ) -> place( -x => 50 , -y => 47 );

	$Fenster_Fehler_Hilfe -> Label( -text   => ':'      ,
								    -height => 1        ,
								    -width  => 1        ,
									-border => 0        ,									
								    -relief => 'groove' ,
								    -anchor => "w"      
								  
								  ) -> place( -x => 166 , -y => 47 );

	$Fenster_Fehler_Hilfe -> Entry( -width    => 12         , 
								    -relief   => 'groove'   , 
								    -bd       => 1          ,
								    -justify  => 'center'   ,
									-state    => 'readonly' ,
									-readonlybackground => 'white' ,
									-text     => $Fehler_Hilfe_Identifier
                                   
								    
								   ) -> place( -x =>  192 , -y => 47 );																					  																				
	
	# ---------------------------------------------------------------------------------------------------------
								  
	$Fenster_Fehler_Hilfe -> Label( -text   => "Betroffene Bereiche" ,
								    -height => 1        ,
								    -width  => 16       , 
									-border => 0        ,
								    -relief => 'groove' ,
								    -anchor => "w"      
								  
								  ) -> place( -x => 50 , -y => 75 );
								  
								  
	$Fenster_Fehler_Hilfe -> Label( -text   => ':'      ,
								    -height => 1        ,
								    -width  => 1        ,
									-border => 0        ,									
								    -relief => 'groove' ,
								    -anchor => "w"      
								  
								  ) -> place( -x => 166 , -y => 75 );

	$Fenster_Fehler_Hilfe -> Entry( -width    => 49         , 
								    -relief   => 'groove'   , 
								    -bd       => 1          ,
								    -justify  => 'center'   , 
									-state    => 'readonly' ,
									-readonlybackground => 'white' ,
									-text     => $Betroffene_Bereiche
                                   
								    
								   ) -> place( -x =>  192 , -y => 75 );								  

	# ---------------------------------------------------------------------------------------------------------

	$Fenster_Fehler_Hilfe -> Frame( -background  => 'black'  ,
									-borderwidth => 1            ,
								    -width       => 442          , 
	                                -height      => 1            ,
								    -relief      => 'groove'
								    
								    ) -> place( -x => 50 , -y => 112 );
									
	$Fenster_Fehler_Hilfe -> Label( -text   => "Fehler - Beschreibung" ,
								    -height => 1        ,
								    -width  => 20       , 
									-border => 0        ,
								    -relief => 'groove' ,
								    -anchor => "w"      
								  
								  ) -> place( -x => 50 , -y => 134 );
	
	$Fenster_Fehler_Hilfe -> Label( -text   => ':'      ,
								    -height => 1        ,
								    -width  => 1        ,
									-border => 0        ,									
								    -relief => 'groove' ,
								    -anchor => "w"      
								  
								  ) -> place( -x => 166 , -y => 134 );	 

	# ---------------------------------------------------------------------------------------------------------

	my $Fenster_Fehler_Hilfe_Beschreibung = $Fenster_Fehler_Hilfe  -> Text( -relief => 'groove' ,
											                                -border => 1        ,
											                                -width  => 63       ,
											                                -height => 7        ,
																			-state  => 'normal'


												                          ) -> place( -x => 50 , -y => 162 );								 

	$Fenster_Fehler_Hilfe_Beschreibung -> insert( 'end' , $SQL_Server_Werte{ $Fehler_Hilfe_Identifier } );	

	$Fenster_Fehler_Hilfe_Beschreibung -> configure('-state'=> 'disabled'); 	
												 
	# ---------------------------------------------------------------------------------------------------------
	
	$Fenster_Fehler_Hilfe -> Frame( -background  => 'black'  ,
									-borderwidth => 1        ,
								    -width       => 442      , 
	                                -height      => 1        ,
								    -relief      => 'groove'
								    
								    ) -> place( -x => 50 , -y => 284 );													  
								   
	$Fenster_Fehler_Hilfe -> Label( -text   => 'Behebung des Fehlers' ,
								    -height => 1                      ,
								    -width  => 20                     , 
									-border => 0                      ,
								    -relief => 'groove'               ,
								    -anchor => "w"      
								  
								  ) -> place( -x => 50 , -y => 305 );
								  
	$Fenster_Fehler_Hilfe -> Label( -text   => ':'      ,
								    -height => 1        ,
								    -width  => 1        ,
								    -border => 0        ,									
								    -relief => 'groove' ,
								    -anchor => "w"      
								  
								  ) -> place( -x => 166 , -y => 305 );	
								  
	my $text = $Fenster_Fehler_Hilfe  -> Text( -relief  => 'groove' ,
											   -border  => 1        ,
											   -width   => 63       ,
											   -height  => 7        ,

											 ) -> place( -x => 50 , -y => 335 );
	
	# ---------------------------------------------------------------------------------------------------------								 

	$Fenster_Fehler_Hilfe -> Button( -text    => ' Reperatur ' , 
	                                 -width   => 33            , 
	                                 -height  => 2             , 
	                                 -command => sub{ &Reparatur_Config( ) }	
									 
									) -> place( -x => 50 , -y => 485 );

	$Fenster_Fehler_Hilfe -> Button( -text    => ' Ende ' , 
	                                 -width   => 33       , 
	                                 -height  => 2        , 
	                                 -command => sub{ 
									                   $Fenster_Fehler_Hilfe -> destroy;													   
													   exit( 0 );  
									                }	
									 
									) -> place( -x => 287 , -y => 485 );									
	MainLoop( );

	# ---------------------------------------------------------------------------------------------------------								   
	
}

# ---------------------------------------------------------------------------------------------------------	

1;