#!/usr/bin/perl
        
# ----------------------------------------------------------------------------------------------------------------------------
   
use strict;
use warnings;

# use utf8;

use Tk;
use Tk::ProgressBar;

use Win32;
use Win32::GUI;
use Win32::Process;
 
use Modules::Hilfe;

# ----------------------------------------------------------------------------------------------------------------------------

 
sub Parser_Initialisierung( $ )
{
	
	# Strings für die Prüfung der Einträge des Config - Files
	# Auslagerung !?
	
	my @Config_Pruefung_Eintraege = ( "MAILING_SERVER_ADRESSE"     ,   				 
					                  "MAILING_SERVER_PORT"        ,      
                                      "MAILING_SERVER_SECURITY"    ,	 
                                      "MAILING_SERVER_DEBUG_MODUS" ,
                                      
                                      "SSL_SERVER_ADRESSE" ,
                                      "SSL_SERVER_PORT"    ,
                                      
                                      "SSL_SERVER_PUBLIC_KEY_FOLDER"      ,	    
                                      "SSL_SERVER_PUBLIC_KEY_IDENTIFIER"  , 
                                      "SSL_SERVER_PRIVATE_KEY_FOLDER"     ,	
                                      "SSL_SERVER_PRIVATE_KEY_IDENTIFIER" ,
									  
									  "SQL_SERVER_ADRESSE"       ,
									  "SQL_SERVER_PORT"          ,
									  "SQL_SERVER_IDENTIFIER"    ,
									  "SQL_SERVER_SECURITY_CODE" ,
							 
							        );
									
	my $Zaehler_Config_Pruefung_Eintraege = @Config_Pruefung_Eintraege;																															# Zaehler fuer die Eintraege der Config - Datei							

	# ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	my $File_Handler = "test.txt";		                                        																												# Bezeichnung der Config - Datei
	local *CF;                                                                  																												# Lokale Adressierung
																														
	if( not -e $File_Handler ) 																																									# Bei Nicht - Existenz der Datei
	{ 																													
		my $Fehler_Verarbeitung_Nummer = "0001";                       																															# Fehler - Code
		&Fehler_Verarbeitung( $Fehler_Verarbeitung_Nummer );           																															# Aufruf der Sub - Routine fuer die Fehler - Verarbeitung
		# exit( 0 );                                                     																															# Schließung des Scripts
	}																														
																														
	open( CF ,'<' . $File_Handler );																																							# Öffnung des File - Handlers
	read( CF , my $Inhalte , -s $File_Handler );  																																				# ERGÄNZUNG
	close( CF );                                   																																				# Schließung des File - Handlers

	# ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	my @Config_Eintraege_Sammlung  = split( /\015\012|\012|\015/ , $Inhalte );																													# Aufteilung & Speicherung der Werte
	my $Config_Eintraege = { };                                                 																												# Initialisierung des Platz - Halters für die Speicherung der Config - Eintraege
	my $Zaehler_Zeile = 0;                                                      																												# Initialisierung des Zaehlers für jede Zeile der Config - Datei
	
	my $Zaehler_Config_Pruefung = 0;																																							# Initialisierung des Zaehlers für die Verarbeitung der Config - Datei

	for ( $Zaehler_Config_Pruefung = 0 ;$Zaehler_Config_Pruefung < $Zaehler_Config_Pruefung_Eintraege ; $Zaehler_Config_Pruefung++ ) 
	{ 
		my $Zaehler_Config_Pruefung_Treffer = 0;																																				# Zaehler für die Treffer bei der Prüfung der Config - Eintraege
		
		foreach my $Config_Eintraege_Zeile( @Config_Eintraege_Sammlung )
		{
			$Zaehler_Zeile++;																																									# Erhöhung des Wertes des Zaehlers für jede Zeile der Config - Datei
		
			next if( $Config_Eintraege_Zeile =~ /^\s*#/ );																																		# ERGAENZUNG
			next if( $Config_Eintraege_Zeile !~ /^\s*\S+\s*=.*$/ );																																# ERGAENZUNG 
			
			my $Config_Eintraege_Positionierung = index( $Config_Eintraege_Zeile , "=" );																										# Trennung der Schluessel & Werte jeder Zeile der Config - Datei	

			my $Config_Eintraege_Ergebnis = substr( $Config_Eintraege_Zeile , 0 , $Config_Eintraege_Positionierung - 1 );																		# Ermittlung des Config - Eintrags
						
			if( $Config_Eintraege_Ergebnis eq $Config_Pruefung_Eintraege[ $Zaehler_Config_Pruefung ] )																							# Ergebnis der Pruefung : Treffer
			{
				$Zaehler_Config_Pruefung_Treffer++;																																				# Erhoehung des Wertes
			}
		}
		
		if( $Zaehler_Config_Pruefung_Treffer == 0 )																																				# Ergebnis der Pruefung : Keine Treffer
		{
			my $Fehler_Verarbeitung_Nummer = "0002";                       																														# Fehler - Code																																																
			&Fehler_Verarbeitung( $Fehler_Verarbeitung_Nummer );            																													# Aufruf der Fehler - Verarbeitung & Übergabe des Fehler - Codes
			# exit( 0 );                                                      																													# Schließung des Scripts
		}					
	}

	# ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
						
	foreach my $Config_Eintraege_Zeile( @Config_Eintraege_Sammlung )					
	{					
		$Zaehler_Zeile++;																																										# Erhöhung des Wertes für Zaehler des Config - Eintrags ( + 1 )					
							
		next if( $Config_Eintraege_Zeile =~ /^\s*#/ );								
		next if( $Config_Eintraege_Zeile !~ /^\s*\S+\s*=.*$/ );						
							
		my ( $File_Handler_Keys , $File_Handler_Values ) = split( /=/ , $Config_Eintraege_Zeile , 2 );																							# Aufteilung der Inhalte der Datei pro Zeile
																																																# Werte 	 - $File_Handler_Keys
																																																# Schluessel - $File_Handler_Values
																																																# Basis für die Trennung der Inhalte : /=/
							
		# Entfernung der Whitespaces am Anfang & Ende der Zeile					
							
		$File_Handler_Keys   =~ s/^\s+//g; 																																						# 1. Step - 
		$File_Handler_Keys   =~ s/\s+$//g; 																																						# 2. Step - 
		$File_Handler_Values =~ s/^\s+//g; 																																						# 3. Step - 
		$File_Handler_Values =~ s/\s+$//g; 																																						# 4. Step - 
							
		# Prüfung jeder Zeile der Datei - Doppelte Werte							
		
		die "Doppelter Eintrag '$File_Handler_Keys' in Zeile $Zaehler_Zeile der Config - Datei '$File_Handler'" if( $Config_Eintraege -> { $File_Handler_Keys } );								# ERGAENZUNG - Fehler - Code : 0003
		
		$Config_Eintraege -> { $File_Handler_Keys } = $File_Handler_Values; 																													# Übertragung der Config - Werte aus der Datei 
	}
	
	return $Config_Eintraege;																																									# Rückgabe der Config - Werte
}
 
# ----------------------------------------------------------------------------------------------------------------------------

sub Fehler_Verarbeitung {

	# Übergabe des Fehler - Codes aus Sub - Routine

	my $Fehler_Verarbeitung_Code = $_[ 0 ];	  		

	# Initialisierung des Fehler - Fensters
	
	my $Fehler_Verarbeitung_Fenster = new Win32::GUI::Window( -name        => "Fehler_Verarbeitung",
                                                              -title       => "Fehler - Verarbeitung",
                                                              -pos         => [ 100, 100 ] ,
                                                              -size        => [ 350, 150 ] ,
															  -resizabble  => 0 ,
															  -helpbox     => 1 ,
															  -minimizebox => 0 ,
															  -maximizebox => 0 ,
															  -topmost     => 1 ,   
                 
                                            				);
	
	# Initialisierung der Schrift für Texte des Fehler - Fensters
	
	my $Fehler_Verarbeitung_Schrift_Generelles = Win32::GUI::Font -> new( -size      => 8 ,
															              -bold      => 0 ,	
															              -underline => 0 );

	# Initialisierung der Schrift für Verweise des Fehler - Fensters
																		  
	my $Fehler_Verarbeitung_Schrift_Verweise = Win32::GUI::Font -> new( -size      => 8 ,
											  			                -bold      => 0 ,	
															            -underline => 1 );
	
	# Allgemeine Fehler - Meldung	
		
	$Fehler_Verarbeitung_Fenster -> AddLabel( -text  => "Fehler bei der Ausfuehrung des Befehls." ,
											  -font  => $Fehler_Verarbeitung_Schrift_Generelles   ,
								  	  		  -pos   => [ 100 , 25 ] );

	# Spezifischer Fehler - Code											
											  
	$Fehler_Verarbeitung_Fenster -> AddLabel( -text  => "Aktueller Fehler - Code : $Fehler_Verarbeitung_Code" ,
											  -font  => $Fehler_Verarbeitung_Schrift_Generelles ,
								  	  		  -pos   => [ 100 , 45 ] );

	# Allgemeiner Verweis auf die Fehler - Verwaltung										  
												
	$Fehler_Verarbeitung_Fenster -> AddLabel( -text    => "Mehr ..." ,
											  -onClick => sub{ \&Fehler_Hilfe_Oberflaeche( $Fehler_Verarbeitung_Code , $Fehler_Verarbeitung_Fenster ) }  ,
											  -font    => $Fehler_Verarbeitung_Schrift_Verweise ,
											  -notify  => 1 ,
								  	  		  -pos     => [ 100 , 75 ] );
												  
	$Fehler_Verarbeitung_Fenster -> Enable( );																																						# Aktivierung des Fensters	
	$Fehler_Verarbeitung_Fenster -> Show( );																																						# Darstellung des Fensters
											
	Win32::GUI::Dialog;											
}											
											
# FERTIG											
# ----------------------------------------------------------------------------------------------------------------------------

sub Parser_Pruefung {											
											
	use Data::Validate::IP;											
												
	my $Config_Eintraege = &Parser_Initialisierung( );																																				# Aufruf des Config - Files & Speicherung der Einträge
																														
	if ( not is_ipv4( $Config_Eintraege -> { SSL_SERVER_ADRESSE } ) )																																# Prüfung der IP - Adresse des SSL - Servers 
	{																													
		my $Fehler_Verarbeitung_Nummer = "3000";																																					# Fehler - Code
																																	
		&Fehler_Verarbeitung( $Fehler_Verarbeitung_Nummer );																																		# Aufruf der Fehler - Verarbeitung & Übergabe des Fehler - Codes
		# exit( 0 );																																													# Schließung des Scripts		
	}																													
																														
	if( $Config_Eintraege -> { SSL_SERVER_PORT } !~ /^[0-9]*$/  ) 																																	# Prüfung des Ports des SSL - Servers
	{ 																													
		my $Fehler_Verarbeitung_Nummer = "3001";                            																														# Fehler - Code
																															
		&Fehler_Verarbeitung( $Fehler_Verarbeitung_Nummer );																																		# Aufruf der Fehler - Verarbeitung & Übergabe des Fehler - Codes
		# exit( 0 );																																													# Schließung des Scripts
	}											
												
	my $Pruefung_SSL_Pubic_Keys_Verzeichnis   = $Config_Eintraege -> { SSL_SERVER_PUBLIC_KEY_FOLDER };																								# Verzeichnis des SSL Public Keys
	my $Pruefung_SSL_Private_Keys_Verzeichnis = $Config_Eintraege -> { SSL_SERVER_PRIVATE_KEY_FOLDER };																								# Verzeichnis des SSL Private Keys
												
	if ( not -e $Pruefung_SSL_Pubic_Keys_Verzeichnis ) 											
	{											
		my $Fehler_Verarbeitung_Nummer = "3002";																																					# Fehler - Code
																																																	
		&Fehler_Verarbeitung( $Fehler_Verarbeitung_Nummer );                    																													# Aufruf der Fehler - Verarbeitung & Übergabe des Fehler - Codes
		# exit( 0 );                                                              																													# Schließung des Scripts
												
	} else {											
				if( not -e $Config_Eintraege -> { SSL_SERVER_PUBLIC_KEY_FOLDER } . $Config_Eintraege -> { SSL_SERVER_PUBLIC_KEY_IDENTIFIER } )											
				{											
					my $Fehler_Verarbeitung_Nummer = "3004";                       																													# Fehler - Code
																																
					my $Fehler_Rueckmeldung = &Fehler_Verarbeitung( $Fehler_Verarbeitung_Nummer );                                              													# Aufruf der Fehler - Verarbeitung & Übergabe des Fehler - Codes
					return( "Fehler" );																																												# Schließung des Scripts
				}                                                                                                     																				
			}                                                                                                         																				
																																																	
	if ( not -e $Pruefung_SSL_Private_Keys_Verzeichnis )                                                              																				
	{                                                                                                                 																				
		my $Fehler_Verarbeitung_Nummer = "3003";                                                                      																				# Fehler - Code
																																																	
		&Fehler_Verarbeitung( $Fehler_Verarbeitung_Nummer );                                                          																				# Aufruf der Fehler - Verarbeitung & Übergabe des Fehler - Codes
		# exit( 0 );                                                                                                    																			# Schließung des Scripts
												
	} else {											
				if( not -e $Config_Eintraege -> { SSL_SERVER_PRIVATE_KEY_FOLDER } . $Config_Eintraege -> { SSL_SERVER_PRIVATE_KEY_IDENTIFIER } )											
				{											
					my $Fehler_Verarbeitung_Nummer = "3005";                        																												# Fehler - Code
																																																	
					&Fehler_Verarbeitung( $Fehler_Verarbeitung_Nummer );            																												# Aufruf der Fehler - Verarbeitung & Übergabe des Fehler - Codes
					# exit( 0 );                                                      																												# Schließung des Scripts
				}																		                                                                    										 
			}																		                                                                        										 
																																																	
	if( not is_ipv4( $Config_Eintraege -> { SQL_SERVER_ADRESSE } ) )																																# Prüfung der IP - Adresse des SQL - Servers
	{ 																		                                                                                										 
		my $Fehler_Verarbeitung_Nummer = "2000";                            																														# Fehler - Code
																																																	
		&Fehler_Verarbeitung( $Fehler_Verarbeitung_Nummer );																																		# Aufruf der Fehler - Verarbeitung & Übergabe des Fehler - Codes
		# exit( 0 );																																												# Schließung des Scripts
	}																		                                                                                										 
																																																	
	if( $Config_Eintraege -> { SQL_SERVER_PORT } !~ /^[0-9]*$/  ) 																																	# Prüfung des Ports des SQL - Servers
	{ 																		                                                                                										 
		my $Fehler_Verarbeitung_Nummer = "2001";                            																														# Fehler - Code
																																																	
		&Fehler_Verarbeitung( $Fehler_Verarbeitung_Nummer );																																		# Aufruf der Fehler - Verarbeitung & Übergabe des Fehler - Codes
		# exit( 0 );																																												# Schließung des Scripts
	}
	
}

# FERTIG			
# ----------------------------------------------------------------------------------------------------------------------------

1;